/*
 * Initialization file etc.
 */
#include "fm.h"
#include "myctype.h"
#include <stdio.h>
#include <errno.h>
#include "parsetag.h"
#include "local.h"

static int rc_initialized = 0;
char *rc_dir;

#ifdef USE_HISTORY
extern Hist *URLHist;
#endif

#define P_INT      0
#define P_SHORT    1
#define P_CHARINT  2
#define P_CHAR     3
#define P_STRING   4

#if LANG == JA
#define CMT_TABSTOP      ""
#define CMT_PAGERLINE    "ڡȤѤ¸Կ"
#define CMT_HISTSIZE     "ݻURLο"
#define CMT_SAVEHIST     "URL¸"
#define CMT_KANJICODE    "ɽѴ"
#define CMT_FRAME        "ե졼μưɽ"
#define CMT_DISPLINK     "μưɽ"
#define CMT_MULTICOL     "ե̾Υޥɽ"
#define CMT_COLOR        "顼ɽ"
#define CMT_B_COLOR      "ʸο"
#define CMT_A_COLOR      "󥫡ο"
#define CMT_I_COLOR      "󥯤ο"
#define CMT_F_COLOR      "եο"
#define CMT_BG_COLOR     "طʤο"
#define CMT_ACTIVE_STYLE "򤵤Ƥ󥯤οꤹ"
#define CMT_C_COLOR	 "򤵤Ƥ󥯤ο"
#define CMT_HTTP_PROXY   "HTTPץ(URL)"
#define CMT_GOPHER_PROXY "GOPHERץ(URL)"
#define CMT_FTP_PROXY    "FTPץ(URL)"
#define CMT_NO_PROXY     "ץɥᥤ"
#define CMT_NOPROXY_NETADDR	"ͥåȥɥ쥹ǥץΥå"
#define CMT_DNS_ORDER	"̾ν"
#define CMT_DROOT        "/ ɽǥ쥯ȥ(document root)"
#define CMT_PDROOT       "/~user ɽǥ쥯ȥ"
#define CMT_CGIBIN       "/cgi-bin ɽǥ쥯ȥ"
#define CMT_CONFIRM_QQ   "q Ǥνλ˳ǧ"
#define CMT_SHOW_NUM     "ֹɽ"
#define CMT_EDITOR       "Ѥ륨ǥ"
#define CMT_MAILER       "Ѥ᡼"
#define CMT_EXTBRZ       "֥饦"
#define CMT_EXTBRZ2      "֥饦2"
#define CMT_EXTBRZ3      "֥饦3"
#define CMT_FTPPASS      "FTPΥѥ(̤ϼʬmail addressȤ)"
#define CMT_USERAGENT    "User-Agent"
#define CMT_ACCEPTLANG   "Ĥ(Accept-Language:)"
#define CMT_WRAP         "ޤ֤"
#define CMT_USECOOKIE "åѤ"
#define CMT_BGEXTVIEW    "ӥ塼Хå饦ɤư"
#define CMT_EXT_DIRLIST  "ǥ쥯ȥꥹȤ˳ޥɤȤ"
#define CMT_DIRLIST_CMD  "ǥ쥯ȥꥹѥޥ"
#else
#define CMT_TABSTOP      "Tab width"
#define CMT_PAGERLINE    "# of reserved line when w3m is used as a pager"
#define CMT_HISTSIZE     "# of reserved URL"
#define CMT_SAVEHIST     "Save URL history"
/* #define CMT_KANJICODE    "Display Kanji Code" */
#define CMT_FRAME        "Automatic rendering of frame"
#define CMT_DISPLINK     "Automatic display of link URL"
#define CMT_MULTICOL     "Multi-column output of file names"
#define CMT_COLOR        "Display with color"
#define CMT_B_COLOR      "Color of normal character"
#define CMT_A_COLOR      "Color of anchor"
#define CMT_I_COLOR      "Color of image link"
#define CMT_F_COLOR      "Color of form"
#define CMT_ACTIVE_STYLE "Use active link color"
#define CMT_C_COLOR	 "Color of currently active link"
#define CMT_BG_COLOR     "Color of background"
#define CMT_HTTP_PROXY   "URL of HTTP proxy host"
#define CMT_GOPHER_PROXY "URL of GOPHER proxy host"
#define CMT_FTP_PROXY    "URL of FTP proxy host"
#define CMT_NO_PROXY     "Domains for direct access (no proxy)"
#define CMT_NOPROXY_NETADDR	"Check noproxy by network address"
#define CMT_DNS_ORDER	"Order of name resolution"
#define CMT_DROOT        "Directory corresponds to / (document root)"
#define CMT_PDROOT       "Directory corresponds to /~user"
#define CMT_CGIBIN       "Directory corresponds to /cgi-bin"
#define CMT_CONFIRM_QQ   "Confirm when quitting with q"
#define CMT_SHOW_NUM     "Show line number"
#define CMT_EDITOR       "Editor"
#define CMT_MAILER       "Mailer"
#define CMT_EXTBRZ       "External Browser"
#define CMT_EXTBRZ2      "Second External Browser"
#define CMT_EXTBRZ3      "Third External Browser"
#define CMT_FTPPASS      "Password for FTP(use your mail address)"
#define CMT_USERAGENT    "User-Agent"
#define CMT_ACCEPTLANG   "Accept-Language"
#define CMT_WRAP         "Wrap search"
#define CMT_USECOOKIE   "Use Cookie"
#define CMT_BGEXTVIEW    "Background an external viewer"
#define CMT_EXT_DIRLIST  "Use external program for directory listing"
#define CMT_DIRLIST_CMD  "Directory listing command"
#endif

#define PI_TEXT    0
#define PI_ONOFF   1
#define PI_SEL_C   2

#ifdef JP_CHARSET
static char *kcodestr[] = {
  "E - EUC",
  "S - Shift_JIS",
  "j - JIS X0208-1978 + JIS X0201-1976",
  "N - JIS X0208-1983 + JIS X0201-1976",
  "m - JIS X0208-1978 + US_ASCII",
  "n - JIS X0208-1983 + US_ASCII",
  NULL};
#endif

#ifdef COLOR
static char *colorstr[] = {
#if LANG== JA
  "0:","1:","2:","3:","4:","5:","6:","7:","8:ü",NULL
#else
  "0:black","1:red","2:green","3:yellow","4:blue","5:magenta","6:cyan","7:white","8:terminal",NULL
#endif
  };
#endif

#ifdef INET6
static char *dnsorders[] = {
    "0:unspec",
    "1:inet inet6",
    "2:inet6 inet",
    NULL,
};
#endif

struct param_section {
  char *name;
  struct param_ptr *params;
};

struct param_ptr {
  char *name;
  int  type;
  int  inputtype;
  void *varptr;
  char *comment;
  char **select;
};

static struct param_ptr params1[] = {
  {"tabstop",         P_INT,    PI_TEXT,  (void*)&Tabstop,CMT_TABSTOP,NULL},
#ifdef JP_CHARSET
  {"kanjicode",       P_CHAR,   PI_SEL_C, (void*)&DisplayCode, CMT_KANJICODE,kcodestr},
#endif
  {"frame",           P_CHARINT,PI_ONOFF, (void*)&RenderFrame, CMT_FRAME, NULL},
{"display_link",    P_INT,    PI_ONOFF, (void*)&displayLink, CMT_DISPLINK,NULL},
  {"ext_dirlist",     P_INT,    PI_ONOFF, (void*)&UseExternalDirBuffer,CMT_EXT_DIRLIST,NULL},
  {"dirlist_cmd",     P_STRING, PI_TEXT,  (void*)&DirBufferCommand,CMT_DIRLIST_CMD,NULL},
  {"multicol",        P_INT,    PI_ONOFF, (void*)&multicolList, CMT_MULTICOL,NULL},
  {NULL, 0, 0, NULL, NULL, NULL},
};

#ifdef COLOR
static struct param_ptr params2[] = {
  {"color",           P_INT,    PI_ONOFF, (void*)&useColor,CMT_COLOR,NULL},
  {"basic_color",     P_INT,    PI_SEL_C, (void*)&basic_color,CMT_B_COLOR,colorstr},
  {"anchor_color",    P_INT,    PI_SEL_C, (void*)&anchor_color,CMT_A_COLOR,colorstr},
  {"image_color",     P_INT,    PI_SEL_C, (void*)&image_color,CMT_I_COLOR,colorstr},
  {"form_color",      P_INT,    PI_SEL_C, (void*)&form_color,CMT_F_COLOR,colorstr},
#ifdef BG_COLOR
  {"bg_color",        P_INT,    PI_SEL_C, (void*)&bg_color,CMT_BG_COLOR,colorstr},
#endif
  {"active_style",    P_INT,    PI_ONOFF, (void*)&useActiveColor, CMT_ACTIVE_STYLE, NULL},
  {"active_color",    P_INT,    PI_SEL_C, (void*)&active_color,CMT_C_COLOR,colorstr},
  {NULL, 0, 0, NULL, NULL, NULL},
};
#endif


static struct param_ptr params3[] = {
  {"pagerline",       P_INT,    PI_TEXT,  (void*)&PagerMax,CMT_PAGERLINE,NULL},
#ifdef USE_HISTORY
  {"history",         P_INT,    PI_TEXT,  (void*)&URLHistSize,CMT_HISTSIZE,NULL},
  {"save_hist",       P_INT,    PI_ONOFF, (void*)&URLSaveHist,CMT_SAVEHIST,NULL},
#endif
  {"confirm_qq",      P_INT,    PI_ONOFF, (void*)&confirm_on_quit, CMT_CONFIRM_QQ,NULL},
  {"show_lnum",       P_INT,    PI_ONOFF, (void*)&showLineNum, CMT_SHOW_NUM,NULL},
  {"ftppasswd",       P_STRING, PI_TEXT,  (void*)&ftppasswd, CMT_FTPPASS, NULL},
  {"user_agent",      P_STRING, PI_TEXT,  (void*)&UserAgent, CMT_USERAGENT,NULL},
  {"accept_language", P_STRING, PI_TEXT,  (void*)&AcceptLang, CMT_ACCEPTLANG, NULL},
  {"wrap_search",     P_INT,    PI_ONOFF, (void*)&WrapDefault, CMT_WRAP, NULL},
#ifdef USE_COOKIE
  {"use_cookie",   P_INT,    PI_ONOFF, (void*)&use_cookie, CMT_USECOOKIE, NULL},
#endif
  {NULL, 0, 0, NULL, NULL, NULL},
};

static struct param_ptr params4[] = {
  {"http_proxy",      P_STRING, PI_TEXT,  (void*)&HTTP_proxy,CMT_HTTP_PROXY,NULL},
  {"gopher_proxy",    P_STRING, PI_TEXT,  (void*)&GOPHER_proxy,CMT_GOPHER_PROXY,NULL},
  {"ftp_proxy",       P_STRING, PI_TEXT,  (void*)&FTP_proxy,CMT_FTP_PROXY,NULL},
  {"no_proxy",        P_STRING, PI_TEXT,  (void*)&NO_proxy,CMT_NO_PROXY,NULL},
  {"noproxy_netaddr", P_INT,	PI_ONOFF, (void*)&NOproxy_netaddr, CMT_NOPROXY_NETADDR, NULL },
#ifdef INET6
  {"dns_order",	      P_INT, PI_SEL_C,  (void*)&DNS_order,CMT_DNS_ORDER, dnsorders},
#endif
  {NULL, 0, 0, NULL, NULL, NULL},
};

static struct param_ptr params5[] = {
  {"document_root",   P_STRING, PI_TEXT,  (void*)&document_root,CMT_DROOT,NULL},
  {"personal_document_root",P_STRING,PI_TEXT,(void*)&personal_document_root,CMT_PDROOT,NULL},
  {"cgi_bin", P_STRING, PI_TEXT, (void*)&cgi_bin, CMT_CGIBIN,NULL},
  {NULL, 0, 0, NULL, NULL, NULL},
};

static struct param_ptr params6[] = {
  {"editor",          P_STRING, PI_TEXT,  (void*)&Editor,CMT_EDITOR,NULL},
  {"mailer",          P_STRING, PI_TEXT,  (void*)&Mailer,CMT_MAILER,NULL},
  {"extbrowser",      P_STRING, PI_TEXT,  (void*)&ExtBrowser,CMT_EXTBRZ},
  {"extbrowser2",     P_STRING, PI_TEXT,  (void*)&ExtBrowser2,CMT_EXTBRZ2},
  {"extbrowser3",     P_STRING, PI_TEXT,  (void*)&ExtBrowser3,CMT_EXTBRZ3},
  {"bgextviewer",     P_INT,    PI_ONOFF, (void*)&BackgroundExtViewer,CMT_BGEXTVIEW},
  {NULL,              0,        0, NULL, NULL, NULL},
};

static struct param_section sections[] =
{
#if LANG == JA
  {"ɽط", params1},
#ifdef COLOR
  {"ɽ", params2},
#endif
  {"¾",params3},
  {"ץ",params4},
  {"ǥ쥯ȥ", params5},
  {"ץ",params6},
#else
  {"Display", params1},
#ifdef COLOR
  {"Color Setting", params2},
#endif
  {"Other Behavior",params3},
  {"Proxy Setting",params4},
  {"Directory Setting", params5},
  {"External Programs",params6},
#endif
  {NULL,NULL}
};  

static struct param_ptr*
search_param(char *name)
{
  int i,j;
  for (j = 0; sections[j].name != NULL; j++) {
    i = 0;
    while (sections[j].params[i].name) {
      if (strcmp(sections[j].params[i].name,name) == 0)
	return &sections[j].params[i];
      i++;
    }
  }
  return NULL;
}

static int
set_param(char *name, char *value)
{
  struct param_ptr *p;

  if (value == NULL || *value == '\0')
    return 0;
  p = search_param(name);
  if (p == NULL) return 0;
  switch(p->type) {
  case P_INT:
    *(int*)p->varptr = atoi(value);
    break;
  case P_SHORT:
    *(short*)p->varptr = atoi(value);
    break;
  case P_CHARINT:
    *(char*)p->varptr = atoi(value);
    break;
  case P_CHAR:
    *(char*)p->varptr = value[0];
    break;
  case P_STRING:
    *(char**)p->varptr = value;
    break;
  }
  return 1;
}

static void
interpret_rc(FILE *f)
{
  Str line;
  Str tmp;
  char *p;

  for (;;) {
    line = Strfgets(f);
    Strchop(line);
    if (line->length == 0)
      break;
    Strremovefirstspaces(line);
    if (line->ptr[0] == '#') /* comment */
      continue;
    tmp = Strnew();
    p = line->ptr;
    while (*p && !IS_SPACE(*p))
      Strcat_char(tmp,*p++);
    while (*p && IS_SPACE(*p))
      p++;
    set_param(tmp->ptr,p);
  }
}

static void
parse_proxy()
{
  if (HTTP_proxy)    parseURL(HTTP_proxy, &HTTP_proxy_parsed, NULL);
  if (GOPHER_proxy)  parseURL(GOPHER_proxy, &GOPHER_proxy_parsed, NULL);
  if (FTP_proxy)     parseURL(FTP_proxy, &FTP_proxy_parsed, NULL);
  if (NO_proxy)      set_no_proxy(NO_proxy);
}

void
init_rc()
{
  char *bm_file1;
  struct stat st;
  Str tmp;
  FILE *f;
  char *tmpdir = "/tmp";

  if (rc_initialized)
    return;
  rc_initialized = 1;

  rc_dir = expandName(RC_DIR);
  if (stat(rc_dir,&st) < 0) {
    if (errno == ENOENT) { /* no directory */
      if (mkdir(rc_dir,0700) < 0) {
	fprintf(stderr,"Can't create config directory (%s)!",rc_dir);
	rc_dir = tmpdir;
	return;
      }
    }
    else {
      fprintf(stderr,"Can't open config directory (%s)!",rc_dir);
      rc_dir = tmpdir;
      return;
    }
  }
  if (!S_ISDIR(st.st_mode)) {
    /* not a directory */
    fprintf(stderr,"%s is not a directory!", rc_dir);
    rc_dir = tmpdir;
    return;
  }

  /* open config file */
  if ((f = fopen(libFile(W3MCONFIG),"r")) != NULL) {
    interpret_rc(f);
    fclose(f);
  }
  if ((f = fopen(rcFile(CONFIG_FILE),"r")) != NULL) {
    interpret_rc(f);
    fclose(f);
  }
  parse_proxy();
  WrapSearch = WrapDefault;
  UserMailcap = loadMailcap(USER_MAILCAP);
  SysMailcap = loadMailcap(SYS_MAILCAP);
}

static char optionpanel_src1[] =
"<html><head><title>Option Setting Panel</title></head>\
<body><center><b>Option Setting Panel</b></center><p><form method=internal action=option>";

static Str
to_str(struct param_ptr *p)
{
    switch (p->type) {
    case P_INT:      return Sprintf("%d",*(int*)p->varptr);
    case P_SHORT:    return Sprintf("%d",*(short*)p->varptr);
    case P_CHARINT:  return Sprintf("%d",*(char*)p->varptr);
    case P_CHAR:     return Sprintf("%c",*(char*)p->varptr);
    case P_STRING:   return Strnew_charp(*(char**)p->varptr);
    }
}

Buffer *
load_option_panel(void)
{
  Str src = Strnew_charp(optionpanel_src1);
  struct param_ptr *p;
  int x,i;
  Str tmp;

  for (i = 0; sections[i].name != NULL; i++) {
    Strcat_charp(src,"<h1>");
    Strcat_charp(src,sections[i].name);
    Strcat_charp(src,"</h1>");
    p = sections[i].params;
    Strcat_charp(src,"<table width=100%>");
    while (p->name) {
      Strcat_charp(src,"<tr><td>");
      Strcat_charp(src,p->comment);
      Strcat_charp(src,"</td><td>");
      switch (p->inputtype) {
      case PI_TEXT:
        Strcat_charp(src,"<input type=text name=");
        Strcat_charp(src,p->name);
        Strcat_charp(src," value=\"");
        Strcat(src,to_str(p));
        Strcat_charp(src,"\">");
        break;
      case PI_ONOFF:
        x = atoi(to_str(p)->ptr);
        Strcat_charp(src,"<input type=radio name=");
        Strcat_charp(src,p->name);
        Strcat_charp(src," value=1");
        if (x) Strcat_charp(src," checked");
        Strcat_charp(src,">ON&nbsp;&nbsp;<input type=radio name=");
        Strcat_charp(src,p->name);
        Strcat_charp(src," value=0");
        if (!x) Strcat_charp(src," checked");
        Strcat_charp(src,">OFF");
        break;
      case PI_SEL_C:
        tmp = to_str(p);
	Strcat_charp(src,"<select name=");
  	Strcat_charp(src,p->name);
	Strcat_charp(src,">");
        for (x = 0; p->select[x] != NULL; x++) {
  	  Strcat_charp(src,"<option value=");
  	  Strcat_char(src,p->select[x][0]);
  	  if (p->select[x][0] == tmp->ptr[0]) 
  	    Strcat_charp(src," selected");
  	  Strcat_char(src,'>');
  	  Strcat_charp(src,p->select[x]);
        }
	Strcat_charp(src,"</select>");
      }
      Strcat_charp(src,"</td></tr>\n");
      p++;
    }
    Strcat_charp(src,"<tr><td></td><td><p><input type=submit value=\"OK\"></td></tr>");
    Strcat_charp(src,"</table><hr width=50%>");
  } 
  Strcat_charp(src,"</form></body></html>");
  return loadHTMLString(src->ptr);
}

void
panel_set_option(struct parsed_tagarg* arg)
{
  FILE *f;

  f = fopen(rcFile(CONFIG_FILE),"w");
  if (f == NULL) {
    disp_message("Can't write option!",NIL);
    backBf();
  }
  while (arg) {
    if (set_param(arg->arg,arg->value)) {
      fprintf(f,"%s %s\n",arg->arg, arg->value);
    }
    arg = arg->next;
  }
  fclose(f);
  parse_proxy();
#ifdef USE_HISTORY
  resizeHist(URLHist, URLHistSize + 1);
#endif
  WrapSearch = WrapDefault;
  backBf();
}

char *
rcFile(char *base)
{
  Str file = Strnew_charp(rc_dir);

  Strcat_char(file, '/');
  Strcat_charp(file, base);
  return expandName(file->ptr);
}

char *
libFile(char *base)
{
  Str file = Strnew_charp(LIB_DIR);

  Strcat_char(file, '/');
  Strcat_charp(file, base);
  return expandName(file->ptr);
}
