#!/usr/bin/perl
#
# Directory list CGI by Hironori Sakamoto (hsaka@mth.biglobe.ne.jp)
#

$CGI = "file:$0";
$FMT = "<a href=\"%s\">%s</a>";
$NOW = time();
$dir = $ENV{'QUERY_STRING'};
if ($dir eq '') {
  $dir = ".";
  $cgi = 0;
} else {
  $cgi = 1;
}
if (! chdir($dir)) {
  $qdir = &html_quote($dir);
  print <<EOF;
Content-Type: text/html

<html>
<head><title>Directory list of $dir/</title></head>
<body>
<b>$qdir</b>: $! !
</body>
</html>
EOF
 exit 1;
}
chop($dir = `pwd`);
$dir =~ s:/$::;
$qdir = &html_quote($dir);

# chop($pwd = `pwd`);
# if ($pwd eq '/') {
#   $upwd = "/";
# }
# else {
#   $pwd =~ s/\/*$//;
#   ($upwd = $pwd) =~ s/\/[^\/]+//;
# }
# if ($dir =~ /^\.\./) {
#   $dir =~ s/^\.\./$upwd/;
# }
# elsif ($dir =~ /^\./) {
#   $dir =~ s/^\./$pwd/;
# }

$cgi && print <<EOF;
w3m-control: DELETE_PREVBUF
EOF
print <<EOF;
Content-Type: text/html

<html>
<head><title>Directory list of $qdir/</title></head>
<body>
<h1>Directory list of $qdir/</h1>
<table hborder width="600">
<tr><td width="200">
<pre>
EOF

@sdirs = split('/', $dir);
if ($dir =~ /^\/*$/) {
  print "<a name=\"current\"></a>";
}
$_ = $sdirs[0];
if ($_ eq '') {
  $_ = '/';
}
$q = &html_quote($_);
printf("$FMT\n", "$CGI?$q#current", "<b>$q</b>");
$N = 0;
$SKIPLINE = "";
&left_dir('', @sdirs);

print <<EOF;
</pre>
</td><td width="400">
<pre>$SKIPLINE
EOF

&right_dir($dir);

print <<EOF;
</pre>
</td></tr>
</table>
</body>
</html>
EOF

sub left_dir {
  local($pre, $dir, @sdirs) = @_;
  local($ok) = (@sdirs == 0);
  local(@cdirs) = ();
  local($_, $d, $qdir, $q);

  $dir .= "/";
  opendir(DIR, $dir) || return;

  foreach(sort readdir(DIR)) {
    -d "$dir$_" || next;
    /^\.$/ && next;
    /^\.\.$/ && next;
    push(@cdirs, $_);
  }
  closedir(DIR);

  $qdir = &html_quote($dir);
  while(@cdirs) {
    $_ = shift @cdirs;
    $q = &html_quote($_);
    $N++;
    if (!$ok && $_ eq $sdirs[0]) {
      $d = $dir . shift @sdirs;
      if (!@sdirs) {
        print "<a name=\"current\"></a>";
        $SKIPLINE = "\n" x $N;
      }
      printf("${pre}o-$FMT\n", "$CGI?$qdir$q#current", "<b>$q</b>");
      &left_dir(@cdirs ? "$pre| " : "$pre  ", $d, @sdirs);
      $ok = 1;
    } else {
      printf("${pre}+-$FMT\n", "$CGI?$qdir$q#current", $q);
    }
  }
}

sub right_dir {
  local($dir) = @_;
  local($_, $qdir, $q, $f);
  local($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
        $atime,$mtime,$ctime,$blksize,$blocks);

  $dir .= "/";
  opendir(DIR, $dir) || return;

  $qdir = &html_quote($dir);
  print "<b>$qdir</b>\n";
  foreach(sort readdir(DIR)) {
    /^\.$/ && next;
    /^\.\.$/ && next;
    $f = "$dir$_";
    (($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
      $atime,$mtime,$ctime,$blksize,$blocks) = lstat($f)) || next;
    $q = &html_quote($_);
    printf "%s %8s %s ", &umode($mode), $size, &utime($ctime);
    if (-d $f) {
      printf($FMT, "$CGI?$qdir$q#current", "$q/");
    } else {
      printf($FMT, "$qdir$q", $q);
    }
    if (-l $f) {
      print " -> ", &html_quote(readlink($f));
    }
    print "\n";
  }
  closedir(DIR);
}

sub html_quote {
  local($_) = @_;
  local(%QUOTE) = (
    '<', '&lt;',
    '>', '&gt;',
    '&', '&amp;',
    '"', '&quote;',
    ' ', '&nbsp;',
  );
  s/[<>&" ]/$QUOTE{$&}/g;
  return $_;
}

sub umode {
  local($_) = @_;
  local(%T) = (
    0010000, 'p',
    0020000, 'c',
    0040000, 'd',
    0060000, 'b',
    0100000, '-',
    0120000, 'l',
    0140000, 's',
  );

  return ($T{($_ & 0170000)} || '-')
     . (($_ & 00400) ? 'r' : '-')
     . (($_ & 00200) ? 'w' : '-')
     . (($_ & 04000) ? 's' :
       (($_ & 00100) ? 'x' : '-'))
     . (($_ & 00040) ? 'r' : '-')
     . (($_ & 00020) ? 'w' : '-')
     . (($_ & 02000) ? 's' :
       (($_ & 00010) ? 'x' : '-'))
     . (($_ & 00004) ? 'r' : '-')
     . (($_ & 00002) ? 'w' : '-')
     . (($_ & 01000) ? 't' :
       (($_ & 00001) ? 'x' : '-'));
}

sub utime {
  local($_) = @_;
  local(@MON) = (
    'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
    'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'
  );
  local($sec,$min,$hour,$mday,$mon,
        $year,$wday,$yday,$isdst) = localtime($_);

  if ($_ > $NOW - 182*24*60*60 && $_ < $NOW + 183*24*60*60) {
    return sprintf("%3s %2d %.2d:%.2d", $MON[$mon], $mday, $hour, $min);
  } else {
    return sprintf("%3s %2d %5d", $MON[$mon], $mday, 1900+$year);
  }
}

